﻿using System;
using System.Text;

namespace RSN.DotP
{
	public class DeckCard
	{
		private CardInfo m_ciCard;
		private int m_nQuantity;
		private int m_nBias;		// A bias level of 1 is no bias.
		private bool m_bPromo;

		public DeckCard(CardInfo ciCard, int nQuantity = 1, int nBias = 1, bool bPromo = false)
		{
			m_ciCard = ciCard;
			m_nQuantity = nQuantity;
			m_nBias = nBias;
			m_bPromo = bPromo;
		}

		public CardInfo Card
		{
			get { return m_ciCard; }
		}

		public int Quantity
		{
			get { return m_nQuantity; }
			set
			{
				if (value < 1)
					value = 1;
				m_nQuantity = value;
			}
		}

		public int Bias
		{
			get { return m_nBias; }
			set { m_nBias = value; }
		}

		public bool Promo
		{
			get { return m_bPromo; }
			set { m_bPromo = value; }
		}

		public string CardDeckName()
		{
			string strName = m_ciCard.Filename;
			if (m_bPromo)
				strName += "#";
			if (m_nBias > 1)
				strName += "@" + m_nBias.ToString();
			return strName;
		}

		// These are card properties that I've exposed from the DeckCard object so
		//	that they can be used for columns in DataGridView since you can't use
		//	"Card.X" for the DataPropertyName.
		public string LocalizedCardName
		{
			get { return m_ciCard.LocalizedName; }
		}

		public string FileName
		{
			get { return m_ciCard.Filename; }
		}

		public string PresentInWad
		{
			get { return m_ciCard.PresentInWad; }
		}
	}
}
